﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;


public class DragHandler : MonoBehaviour, IBeginDragHandler, IDragHandler, IEndDragHandler
{

    public static GameObject itemBeingDragged;
    Vector3 HomePosition;
    Rigidbody2D rb;
    GameObject ObjectUnder;
    string ObjectUnderName="";

    //подпрыгивание объектов
    Vector3 placePosition;
    float DeltaPos;
    float MyVector;

    // Use this for initialization
    void Start () {
        rb = GetComponent<Rigidbody2D>();
        HomePosition = transform.position;

        //подпрыгивание объектов
        placePosition = transform.position;
        MyVector = 0.2f;
    }

    void Update()
    {
        //подпрыгивание объектов
        if (DeltaPos > 1) MyVector = -0.2f;
        if (DeltaPos < -1) MyVector = 0.2f;
        DeltaPos += MyVector;

        if (itemBeingDragged == null && ObjectUnderName == "")
        {
            transform.position = placePosition + new Vector3(0.0f, DeltaPos, 0.0f); ;
        }
    }

    #region IBeginDragHandler implementation

    public void OnBeginDrag(PointerEventData eventData)
    {
        //Запоминаем перетаскиваемый объект и его начальную позицию
        itemBeingDragged = gameObject;
        ObjectUnderName = "";

    }

    #endregion

    #region IDragHandler implementation

    public void OnDrag(PointerEventData eventData)
    {
        //используем RigidBody для отлова пересечений (collider)
        rb.MovePosition(eventData.position);
    }

    #endregion

    #region IEndDragHandler implementation

    public void OnEndDrag(PointerEventData eventData)
    {

        itemBeingDragged = null;

        //проверяем на место ли перетащили
        if (ObjectUnderName == "place1" && this.name == "item1")
        {
            transform.position = ObjectUnder.transform.position;
            //тут можем что то еще делать
        }
        else if (ObjectUnderName == "place2" && this.name == "item2")
        {
            transform.position = ObjectUnder.transform.position;
            //тут можем что то еще делать
        }
        else
        {
            //если нет пересечения возвращаем в исходное положение
            transform.position = HomePosition;
        }

    }

    #endregion

    void OnTriggerEnter2D(Collider2D myCollision)
    {
        // определение столкновения с двумя разноименными объектами
        ObjectUnder = myCollision.gameObject;
        ObjectUnderName = ObjectUnder.name;

    }

    void OnTriggerExit2D(Collider2D myCollision)
    {
        // определение столкновения с двумя разноименными объектами
        ObjectUnder = myCollision.gameObject;
        ObjectUnderName = "";

    }

}
